﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Security.Principal;
using Microsoft.Win32;

namespace APLNext.GetUserAppDataFolder
{
    [Guid("EEB9A900-A5F0-4E2E-B93A-A0D8ED28FB9F")]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface IGUADFP
    {
        [DispId(1)]
        bool FindAppDataFolder(ref string errMsg, ref string uName, ref string dName, ref string sidString, ref string adfPath);
    }
    [Guid("BD818FC3-19EC-49F9-AEB2-870644642171")]
    [ClassInterface(ClassInterfaceType.None)]
    [ProgId("APLNext.GetUserAppDataFolder")]
    public class GUADFP:IGUADFP
    {
        public bool FindAppDataFolder(ref string errMsg, ref string uName, ref string dName, ref string sidString, ref string adfPath)
        {
            bool errCode = false;
            errMsg = "";
            try
            {
                const string regKeyFolders = @"HKEY_USERS\<SID>\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders";
                const string regValueAppData = @"AppData";
                uName = Environment.UserName;
                dName = Environment.UserDomainName;
                if (!String.IsNullOrWhiteSpace(dName))
                {
                    uName = dName + @"\" + uName;
                }
                NTAccount f = new NTAccount(uName);
                SecurityIdentifier s = (SecurityIdentifier)f.Translate(typeof(SecurityIdentifier));
                sidString = s.ToString();
                adfPath = Registry.GetValue(regKeyFolders.Replace("<SID>", sidString), regValueAppData, null) as string;
            }
            catch (Exception e)
            {
                errCode = true;
                errMsg = "FindAppDataFolder failed: " + e.Message;
            }
            return errCode;
        }
    }
}